<div class="row mb-3 align-items-center justify-content-between">
  <div class="col-md-auto col-sm-auto">
    <div class="section-title">
      <h2 *ngIf="!isEditMode">{{'ADD_USER' | translate}}</h2>
      <h2 *ngIf="isEditMode">{{'EDIT_USER' | translate}}</h2>
    </div>
  </div>
</div>

<form [formGroup]="userForm">
  <div class="row">
    <div class="col-md-6">
      <div class="form-group ">
        <label>{{'FIRST_NAME' | translate}}</label>
        <input formControlName="firstName" class="form-control" type="text">
        <div *ngIf="userForm.get('firstName').touched && userForm.get('firstName').errors">
          <div class="text-danger small" *ngIf="userForm.get('firstName').errors?.required">
            {{'FIRST_NAME_IS_REQUIRED' | translate}}
          </div>
        </div>
      </div>
    </div>
    <div class="col-md-6">
      <div class="form-group ">
        <label>{{'LAST_NAME' | translate}}</label>
        <input formControlName="lastName" class="form-control" type="text">
        <div *ngIf="userForm.get('lastName').touched && userForm.get('lastName').errors">
          <div class="text-danger small" *ngIf="userForm.get('lastName').errors?.required">
            {{'LAST_NAME_IS_REQUIRED' | translate}}
          </div>
        </div>
      </div>
    </div>
    <div class="col-md-6">
      <div class="form-group ">
        <label>{{'MOBILE_NUMBER' | translate}}</label>
        <input formControlName="phoneNumber" class="form-control" type="text">
        <div *ngIf="userForm.get('phoneNumber').touched && userForm.get('phoneNumber').errors">
          <div class="text-danger small" *ngIf="userForm.get('phoneNumber').errors?.required">
            {{"MOBILE_IS_REQUIRED" | translate}}
          </div>
        </div>
      </div>
    </div>

    <div class="col-md-6">
      <div class="form-group">
        <label>Email</label>
        <input [attr.disabled]="isEditMode ? '' : null" formControlName="email" class="form-control" type="email">
        <div *ngIf="userForm.get('email').touched && userForm.get('email').errors">
          <div class="text-danger small" *ngIf="userForm.get('email').errors?.required">
            {{'EMAIL_IS_REQUIRED' | translate}}
          </div>
          <div class="text-danger small" *ngIf="userForm.get('email').errors?.email">
            {{'PLEASE_ENTER_VALID_EMAIL' | translate}}
          </div>
        </div>
      </div>
    </div>

    <div *ngIf="!isEditMode" class="col-md-12">
      <div class="form-group">
        <button [disabled]="!userForm.get('firstName').valid" class="btn btn-warning btn-sm mat-small text-light" (click)="autoGeneratePass()">
          {{'AUTO_GENERATE_PASSWORD' | translate}}
        </button>
        <p *ngIf="userForm.get('firstName').valid" class="small mat-small">{{'AUTO_GENERATE_PASSWORD_RESULT' | translate}} {{prefixGeneratedPass}}{{userForm.get('firstName').value}}{{suffixGeneratedPass}}</p>
      </div>
    </div>

    <div *ngIf="!isEditMode" class="form-group col-md-6">
      <label>{{'PASSWORD' | translate}}</label>
      <div class="input-group" style="border-style: none !important;">
        <input #newPassword formControlName="password" class="form-control" type="password" style="width: 80%;" (keyup)="validatePassRequirement()">
        <span class="btn input-group-text box-icon-eye" (click)="showHideNewPass()">
          <i *ngIf="!isNewPassShowed" class="material-icons" style="font-size: 17px;">visibility</i>
          <i *ngIf="isNewPassShowed" class="material-icons" style="font-size: 17px;">visibility_off</i>
        </span>
      </div>
      <!-- <input autocomplete="new-password" formControlName="password" class="form-control" type="password" (keyup)="validatePassRequirement()"> -->
      <div *ngIf="userForm.get('password').touched && userForm.get('password').errors">
        <div class="text-danger small" *ngIf="userForm.get('password').errors?.required">
          {{'PASSWORD_IS_REQUIRED' | translate}}
        </div>
        <div class="text-danger small" *ngIf="userForm.get('password').errors?.minlength">
          {{'YOU_HAVE_TO_ENTER_AT_LEAST_DIGIT' | translate}}
        </div>
      </div>
      <div class="text-danger small" *ngIf="!isPassContainsAlphanumeric">
        {{'PASSWORD_REQUIRED_ALPHANUMERIC' | translate}}
      </div>
      <div class="text-danger small d-flex" *ngIf="!isPassContainsSpecialChar">
        {{'PASSWORD_REQUIRED_SYMBOL' | translate}}
        <span class="ml-1">
          <button
            mat-mini-fab
            class="d-flex justify-content-center align-items-center mat-small"
            [matTooltip]="symbolChar">
            ?
          </button>
        </span>
      </div>
      <div class="text-danger small" *ngIf="!isPassNotContainsSpaceFirstAndLast">
        {{'PASSWORD_DONT_CONTAINS_WHITESPACE_FIRST_LAST' | translate}}
      </div>
    </div>

    <div *ngIf="!isEditMode" class="form-group col-md-6">
      <label>Confirm Password</label>
      <div class="input-group" style="border-style: none !important;">
        <input #confirmPassword formControlName="confirmPassword" class="form-control" type="password" style="width: 80%;">
        <span class="btn input-group-text box-icon-eye" (click)="showHideConfirmPass()">
          <i *ngIf="!isConfirmPassShowed" class="material-icons" style="font-size: 17px;">visibility</i>
          <i *ngIf="isConfirmPassShowed" class="material-icons" style="font-size: 17px;">visibility_off</i>
        </span>
      </div>
      <!-- <input autocomplete="new-password" formControlName="confirmPassword" class="form-control" type="password"> -->
      <div *ngIf="userForm.get('confirmPassword').touched && userForm.get('confirmPassword').errors">
        <div class="text-danger small" *ngIf="userForm.get('confirmPassword').errors?.required">
          {{'CONFIRM_PASSWORD_IS_REQUIRED' | translate}}
        </div>
      </div>
      <div class="text-danger small" *ngIf="userForm.get('confirmPassword').touched && userForm.hasError('notSame')">
        {{'PASSWORDS_DO_NOT_MATCH' | translate}}
      </div>
    </div>

    <div class="form-group mb-2 col-md-6">
      <mat-form-field appearance="fill" class="w-100">
        <mat-label>{{'ROLES' | translate}}</mat-label>
        <mat-select [(value)]="selectedRoles[0]" [multiple]="false">
          <mat-option *ngFor="let role of roleList" [value]="role">
            {{role.name}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <div class="text-danger small" style="margin-top: -1rem;" *ngIf="!isRoleUserValid">
        {{'PLEASE_SELECT_ATLEAST_ONE_ROLE' | translate}}
      </div>
    </div>

    <div class="form-group mb-2 col-md-6">
      <mat-form-field appearance="fill" class="w-100">
        <mat-label>{{'CLIENT_TYPE' | translate}}</mat-label>
        <mat-select [(value)]="selectedClientType[0]" [multiple]="false">
          <mat-option *ngFor="let clientType of clientTypes" [value]="clientType">
            {{clientType.clientType}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <div class="text-danger small" style="margin-top: -1rem;" *ngIf="!isClientTypeUserValid">
        {{'PLEASE_SELECT_ATLEAST_ONE_ROLE' | translate}}
      </div>
    </div>

    <div class="form-group mb-2 col-md-6">
      <mat-form-field appearance="fill" class="w-100">
        <mat-label>{{'ACCOUNT_MANAGER' | translate}}</mat-label>
        <mat-select [(value)]="selectedAccManager[0]" [multiple]="false">
          <mat-option *ngFor="let accManager of accManagers" [value]="accManager">
            {{accManager.name}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <div class="text-danger small" style="margin-top: -1rem;" *ngIf="!isAccManagerUserValid">
        {{'PLEASE_SELECT_ATLEAST_ONE_ROLE' | translate}}
      </div>
    </div>

    <div class="form-group mb-2 col-md-6">
      <mat-form-field appearance="fill" class="w-100">
        <mat-label>Country</mat-label>
        <mat-select [(value)]="selectedCountry[0]" [multiple]="false">
          <mat-option *ngFor="let country of countries" [value]="country">
            {{country.countryName}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <div class="text-danger small" style="margin-top: -1rem;" *ngIf="!isCountryUserValid">
        {{'PLEASE_SELECT_ATLEAST_ONE_ROLE' | translate}}
      </div>
    </div>

    <div class="form-group col-md-6">
      <div class="form-group ">
        <label>{{'COMPANY_NAME' | translate}}</label>
        <input formControlName="companyName" class="form-control" type="text">
        <div *ngIf="userForm.get('companyName').touched && userForm.get('companyName').errors">
          <div class="text-danger small" *ngIf="userForm.get('companyName').errors?.required">
            {{'COMPANY_NAME_IS_REQUIRED' | translate}}
          </div>
        </div>
      </div>
    </div>

    <div class="m-top-10 col-md-12">
      <ng-container *ngIf="isEditMode">
        <button *hasClaim="'user_edit_user'" class="btn btn-success btn-sm m-right-10" (click)="saveUser()" cdkFocusInitial>
          <i class="las la-save mr-1"></i> {{'SAVE' | translate}}
        </button>
      </ng-container>
      <ng-container *ngIf="!isEditMode">
        <button *hasClaim="'user_create_user'" class="btn btn-success btn-sm m-right-10" (click)="saveUser()" cdkFocusInitial>
          <i class="las la-save mr-1"></i> {{'SAVE' | translate}}
        </button>
      </ng-container>
      <button type="button" class="btn btn-danger btn-sm" [routerLink]="['/users']">
        <i class="las la-times-circle mr-1"></i> {{'CANCEL' | translate}}
      </button>
    </div>
  </div>
</form>
